/*-------------------------------------+-------------------------------------*/
/*                                 hardbord.h                                */

#include "board.h"

struct stack {
   stack * previous;
   char oldboard[64];
   state specials;
   unsigned move50;
   unsigned move_n;
   unsigned variation;
   piece * p0;
   field * f0;
   piece * p1;
   field * f1;
   object promotion;
};

struct move {
   piece * p0;
   field * f1;
   object promotion : 6;
   boolean check    : 1;
   boolean mate     : 1;
   move * next;
};

class hardboard {
   stack * sp;
   unsigned move50;
   unsigned move_n;
   unsigned variation;
   void push (piece *, field *, object = PAWN);
   void pop (void);

   const char * lang;
   void insert (unsigned, player, object);
   boolean setup (const char *);

   unsigned n_moves;
   boolean escape (piece *, field *, object = PAWN);
   boolean ismate (void);
   void trial (piece *, field *, object = PAWN);
   void make_movelist (void);

   char (* lanlist)[11];
   char (* sanlist) [8];
   boolean equal (const char *, const char *);
   unsigned lanhit (const char *, unsigned *);
   unsigned sanhit (const char *, unsigned *);
   void make_lanlist (void);
   void make_sanlist (void);
public:
   hardboard (const char * = "", const char * = "");
   void setlang (const char *);
   unsigned execute (const char *);
   void execute (piece *, field *, object = PAWN);
   const char * expand (piece *, field *, object = PAWN);
   void undo (void);
   void start_variation (void);
   void end_variation (void);
   move * movelist;
   boolean drawn_by_3 (void);
   boolean drawn_by_50 (void);

   void show_fen (void);
   void show_board (void);
   void show_lan (void);
   void show_san (void);
   ~hardboard (void);
};

