/*-------------------------------------+-------------------------------------*/
/*                                   main.c                                  */

#include <iostream.h>

void init (void);
void control (void);

enum boolean {FALSE, TRUE};
static boolean fast = FALSE;

boolean strequal (const char * s1, const char * s2)
{
   while (*s1 && *s2)
      if (*s1++ != *s2++)
         return FALSE;
   return (*s1 || *s2) ? FALSE : TRUE;
}

static void get_environment (char ** envir)
{
   while (*envir) {
      if (strequal (*envir, "FAST=true"))
         fast = TRUE;
      envir++;
   }
   return;
}

static int get_arguments (unsigned argc, char ** argv)
{
   unsigned end_of_options = 0;

   unsigned i;
   for (i=1; i<argc && argv[i][0]=='-' && ! end_of_options; i++)
      switch (argv[i][1]) {
      case 'f':
         fast = TRUE;
         break;
      case '-':
      case '\0':
         end_of_options = 1;
         break;
      case '?':
      case 'h':
      default:
         cout << "Usage:  " << argv[0] << " -hf" << endl;
         return 1;
      }

   switch (argc-i) {
   case 2:
   case 1:
   case 0:
      break;
   default:
      cout << "Usage:  " << argv[0] << " -hf" << endl;
      return 1;
   }
   return 0;
}

/*-------------------------------------+-------------------------------------*/

static void opening (void)
{
   const char greeting[] = "\n"
      "Hello, I'm Nessi.\n"
      "How about a nice game of chess?\n";
   unsigned long n;

   cout << "\033[2J" << endl;
   for (const char * cp=greeting; *cp; cp++)
      if (*cp == '\n') {
         cout << endl << endl;
         for (n=0; n<6000000UL; n++)
            ;
      } else if (*cp == ' ') {
         for (n=0; n<400000UL; n++)
            ;
         cout << *cp;
         flush (cout);
      } else {
         for (n=0; n<300000UL; n++)
            ;
         cout << *cp;
         flush (cout);
      }
   return;
}

static void closing (void)
{
   cout << endl;
   cout << "Thank you for playing with Nessi." << endl;
   cout << "Please contribute an evaluation function." << endl;
   cout << endl;
   cout << "Udo Sprute (udo\100sprute.com)" << endl;
   return;
}

int main (unsigned argc, char ** argv, char ** envir)
{
   init ();
   get_environment (envir);
   int result = get_arguments (argc, argv);
   if (! result) {
      if (! fast)
         opening ();
      control ();
      if (! fast)
         closing ();
   }
   return result;
}

/*=====================================+=====================================*/

